//////////////////////////////////////////////////////////
//////////Classe de Gestion de Palette pour VolRender/////
////////////////Cyril Crassin 12 Octobre 2003/////////////
//////////////////////////////////////////////////////////

#include "PaletteCreator.h"
#include <stdlib.h>



void PaletteCreator::draw(){
	glLoadIdentity();

	glTranslatef(0,0,-1.8);
//	glScalef(100,100,100);

	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);

	glColor4f(0,0,0.1,0.5);

	glBegin(GL_QUADS);

	glVertex3f(0,0,0);
	glVertex3f(1,0,0);
	glVertex3f(1,1,0);
	glVertex3f(0,1,0);

	glEnd();

	int i;

	if(activeComp==0)
		glLineWidth(2);
	else
		glLineWidth(1);

	glColor4f(1,0,0,1);

	glBegin(GL_LINE_STRIP );

	for(i=0; i<256; i++){
      glVertex3f(i/255.0, palette[0+i*4], 0);
    }
	glEnd();


	if(activeComp==1)
		glLineWidth(2);
	else
		glLineWidth(1);

	glColor4f(0,1,0,1);

	glBegin(GL_LINE_STRIP );

	for(i=0; i<256; i++){
      glVertex3f(i/255.0, palette[1+i*4], 0);
    }
	glEnd();


	if(activeComp==2)
		glLineWidth(2);
	else
		glLineWidth(1);

	glColor4f(0,0,1,1);

	glBegin(GL_LINE_STRIP );

	for(i=0; i<256; i++){
      glVertex3f(i/255.0, palette[2+i*4], 0);
    }
	glEnd();


	if(activeComp==3)
		glLineWidth(2);
	else
		glLineWidth(1);

	glColor4f(0.8,0.8,0.8,1);

	glBegin(GL_LINE_STRIP );

	for(i=0; i<256; i++){
      glVertex3f(i/255.0, palette[3+i*4], 0);
    }
	glEnd();



}

//deforme les courbes, utilise "enl_interp" pour l'interpolation par splines
void PaletteCreator::acquire(int px, int py){
	/*	palette[activeComp+px*4]=py/255.0;
		palette[activeComp+(px-1)*4]=(palette[activeComp+(px-1)*4]+py/127.0)/3.0;
		palette[activeComp+(px+1)*4]=(palette[activeComp+(px+1)*4]+py/127.0)/3.0;

		palette[activeComp+(px-2)*4]=(palette[activeComp+(px-2)*4]+py/255.0)/2.0;
		palette[activeComp+(px+2)*4]=(palette[activeComp+(px+2)*4]+py/255.0)/2.0;

		palette[activeComp+(px-3)*4]=(palette[activeComp+(px-3)*4]+py/255.0)/2.0;
		palette[activeComp+(px+3)*4]=(palette[activeComp+(px+3)*4]+py/255.0)/2.0;*/

		if(px>255)
			px=255;
		if(px<0)
			px=0;

		ctrlsY[px/27]=py;

	
		enl_interp interp(ctrlsX, ctrlsY, 10);


		double xi=0, yi, x[10], y[10];



		int i=0;
		int tmp=0;

		for(i=0; i<255; i++){
			xi=i/25.0;	
			yi = interp.cspline( xi, &tmp );
			if(yi>255)
				yi=255;
			if(yi<0)
				yi=0;
			palette[activeComp+i*4]=yi/255.0;
		}

	}
